import { OutputDefinitionBlock } from "./definitionBlocks";
export interface NexusExtendTypeConfig<TypeName extends string> {
  type: TypeName;
  definition(t: OutputDefinitionBlock<TypeName>): void;
}
export declare class NexusExtendTypeDef<TypeName extends string> {
  readonly name: TypeName;
  protected config: NexusExtendTypeConfig<string>;
  constructor(name: TypeName, config: NexusExtendTypeConfig<string>);
  readonly value: NexusExtendTypeConfig<string>;
}
/**
 * Adds new fields to an existing type in the schema. Useful when splitting your
 * schema across several domains.
 *
 * @see http://graphql-nexus.com/api/extendType
 */
export declare function extendType<TypeName extends string>(
  config: NexusExtendTypeConfig<TypeName>
): NexusExtendTypeDef<TypeName>;
