"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _types_1 = require("./_types");
var graphql_1 = require("graphql");
var NexusExtendTypeDef = /** @class */ (function () {
    function NexusExtendTypeDef(name, config) {
        this.name = name;
        this.config = config;
        graphql_1.assertValidName(name);
    }
    Object.defineProperty(NexusExtendTypeDef.prototype, "value", {
        get: function () {
            return this.config;
        },
        enumerable: true,
        configurable: true
    });
    return NexusExtendTypeDef;
}());
exports.NexusExtendTypeDef = NexusExtendTypeDef;
_types_1.withNexusSymbol(NexusExtendTypeDef, _types_1.NexusTypes.ExtendObject);
/**
 * Adds new fields to an existing type in the schema. Useful when splitting your
 * schema across several domains.
 *
 * @see http://graphql-nexus.com/api/extendType
 */
function extendType(config) {
    return new NexusExtendTypeDef(config.type, config);
}
exports.extendType = extendType;
//# sourceMappingURL=extendType.js.map