import { GraphQLScalarTypeConfig } from "graphql";
export interface ScalarBase
  extends Pick<
    GraphQLScalarTypeConfig<any, any>,
    "description" | "serialize" | "parseValue" | "parseLiteral"
  > {}
export interface NexusScalarTypeConfig<T extends string> extends ScalarBase {
  /**
   * The name of the scalar type
   */
  name: T;
  /**
   * Any deprecation info for this scalar type
   */
  deprecation?: string;
  /**
   * Adds this type as a method on the Object/Interface definition blocks
   */
  asNexusMethod?: string;
}
export declare class NexusScalarTypeDef<TypeName extends string> {
  readonly name: TypeName;
  protected config: NexusScalarTypeConfig<string>;
  constructor(name: TypeName, config: NexusScalarTypeConfig<string>);
  readonly value: NexusScalarTypeConfig<string>;
}
export declare function scalarType<TypeName extends string>(
  options: NexusScalarTypeConfig<TypeName>
): NexusScalarTypeDef<TypeName>;
